from BinHeapNode import BinHeapNode
'''
Created on 18 Jun 2019

'''

class BinomialHeap(object):
    
    def __init__(self):
        '''
        Constructor of an empty BinomialHeap
        '''
        self._root_nodes_sorted = list();
    
    def _clean_up(self):
        '''
        The merge method. Goes through the sorted list of root nodes and always
        merges two binomial trees with the same index. In the end, there are no
        two subtrees with the same index.
        '''        
        #TODO: Add your code here.
        
    def insert(self, value):
        '''
        Inserts a new value into the BinomialHeap.
        
        Parameters
        ----------
        value : int
            The value to add.
        
        Returns
        -------
        BinHeapNode
            the BinHeapNode storing the new value
        '''    
        #TODO: Add your code here. (You can use clean_up(). )

    
    def delete_min(self):
        '''
        Deletes the smallest element from the BinomialHeap.
        
        Returns
        -------
        int
            The smallest value in the BinomialHeap.
        
        Raises
        ----------
        IndexError
            if the heap is empty    
        '''
        #TODO Add your code here. You can use the clean_up().
   
    def decrease_key (self, node, new_value):
        '''
        Decreases the value of the specified node to the given value.
        
        Parameters
        -------
        node : BinHeapNode
            the node for which we want to decrease the value
        new_value : int
            the new value of the node
        
        Raises
        ----------
        ValueError
            if the new value is larger than the old one    
        '''
        #TODO Add your code here.
    
    def delete(self, node):
        '''
        Deletes the given BinHeapNode.
        
        Parameters
        -------
        node : BinHeapNode
            the node to delete
        '''
        #TODO Add your code here.
     
    @staticmethod    
    def _merge_trees(first, second):
        '''
        Merges the two binomial trees with the specified root nodes to a new binomial tree.
        
        Parameters
        -------
        first : BinHeapNode
            the root node of the first binomial tree
        second : BinHeapNode
            the root node of the second binomial tree
        
        Returns
        ----------
        BinHeapNode
            the root node of the new binomial tree    
        '''
        #TODO: Add your code here!
    
    def __str__(self):
        if ((self._root_nodes_sorted==None) or (len(self._root_nodes_sorted)==0)):
            return "empty heap";
        return_string = "";
        for node in self._root_nodes_sorted:
            return_string+= node.__str__() + " ";
        return return_string;